### Build and deployment performance

  * [GitHub PR 5304](https://github.com/xamarin/xamarin-android/pull/5304):
    Add support for producing a proguard `mapping.txt` file to the
    build system. This file can be used by users to remove this warning

        "This App Bundle contains Java/Kotlin code, which might be obfuscated."

    when uploading packages to the Google Play Store.

    In order to opt-in to this behavior, set the `$(AndroidProguardMappingFile)`
    property in your project file to the path of the file you want generated:

    ```xml
    <PropertyGroup>
      <AndroidProguardMappingFile>$(OutputPath)\mapping.txt</AndroidProguardMappingFile>
    </PropertyGroup>
    ```
