### Build and deployment performance

* [GitHub PR 5311](https://github.com/xamarin/xamarin-android/pull/5311):
  Add support for deploying and debugging against different user accounts
  on Android Devices. In order to use this you need to specify the
  `AndroidDeviceUserId` in either your csproj or on the command line.

   ```xml
    <PropertyGroup>
      <AndroidDeviceUserId>10</AndroidDeviceUserId>
    </PropertyGroup>
    ```

    ```
    msbuild foo.csproj /t:Install /p:AndroidDeviceUserId=10
    ```

    The value is the `uid` value you get from the following adb command

    ```
    adb shell pm list users
    ```

    This will return the following data

    ```
    Users:
      UserInfo{0:Owner:c13} running
      UserInfo{10:Guest:404}
    ```

    The `uid` is the first integer value. In the example they
    are `0` and `10`.