#### Application and library build and deployment

  * [GitHub PR 5372](https://github.com/xamarin/xamarin-android/pull/5372):
    Introduces the **AndroidLibrary** Build Action for Java or Kotlin libraries.

**AndroidLibrary** is a new Build Action can be used as an alternative
to **AndroidAarLibrary**, **AndroidJavaLibrary**, **EmbeddedJar**,
**EmbeddedReferenceJar**, and **LibraryProjectZip**.

For example, in an Android application or class library project:

```xml
<Project>
  <ItemGroup>
    <!-- If the project was using: -->
    <AndroidAarLibrary  Include="foo.aar" />
    <AndroidJavaLibrary Include="bar.jar" />
    <!-- It can now be replaced with: -->
    <AndroidLibrary Include="foo.aar" />
    <AndroidLibrary Include="bar.jar" />
  </ItemGroup>
</Project>
```

In a Java binding project:

```xml
<Project>
  <ItemGroup>
    <!-- If the project was using: -->
    <LibraryProjectZip    Include="foo.aar" />
    <EmbeddedJar          Include="bar.jar" />
    <EmbeddedReferenceJar Include="dependency.jar" />
    <!-- It can now be replaced with: -->
    <AndroidLibrary Include="foo.aar" />
    <AndroidLibrary Include="bar.jar" />
    <AndroidLibrary Include="dependency.jar" Bind="false" />
  </ItemGroup>
</Project>
```

Using the **AndroidLibrary** Build Action is optional, as the old item
names are still supported.

The **AndroidNativeLibrary** Build Action will continue to be used for
native libraries (`.so` files). However one improvement has been
introduced for Xamarin.Android class library or Java binding projects:

```xml
<Project>
  <ItemGroup>
    <!-- If the project was using: -->
    <EmbeddedNativeLibrary Include="lib/armeabi-v7a/libfoo.so" />
    <!-- It can now be replaced with: -->
    <AndroidNativeLibrary Include="lib/armeabi-v7a/libfoo.so" />
  </ItemGroup>
</Project>
```

The **AndroidNativeLibrary** Build Action can now be used in all
project types. It previously was only used in application projects.
