### Application size improvements

  * [GitHub PR 5375](https://github.com/xamarin/xamarin-android/pull/5375):
    Removed decoration of `System.ComponentModel.CategoryAttribute` to
    improve linker behavior. This reduced the .NET assembly size of a
    .NET 6 application by 3,271 bytes.

`CategoryAttribute` was removed from properties on types such as
`Android.App.ActivityAttribute`:

```diff
-[Category ("@drawable;@mipmap")]
public string? Icon { get; set; }
-[Category ("@string")]
public string? Label { get; set; }
```

A full list of types changed:

* `Android.App.ActivityAttribute`
* `Android.App.ApplicationAttribute`
* `Android.App.InstrumentationAttribute`
* `Android.App.ServiceAttribute`
* `Android.Content.BroadcastReceiverAttribute`
* `Android.Content.ContentProviderAttribute`
